/*
Soft PSU button handling code
(C) 2012 Jeroen Domburg (jeroen AT spritesmods.com)

This program is free software: you can redistribute it and/or modify
t under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <stdio.h>
#include <stdlib.h>


void writefile(char *file, char *value) {
    FILE *f;
    f=fopen(file, "w");
    if (f==NULL) {
	perror(file);
	return;
    }
    fprintf(f, "%s", value);
    fclose(f);
}

int main(int argc, char **argv) {
    FILE *f;
    char buff[1024];
    writefile("/sys/class/gpio/export", "30\n");
    if (argc>1) {
	if (strcmp(argv[1], "-pwrdwn")==0) {
	    writefile("/sys/class/gpio/gpio30/direction", "out\n");
	    writefile("/sys/class/gpio/gpio30/value", "0\n");
	} else {
	    printf("%s [-pwrdown]\n", argv[0]);
	    exit(0);
	}
    } else {
	while(1) {
            writefile("/sys/class/gpio/gpio30/direction", "in\n");
    	    f=fopen("/sys/class/gpio/gpio30/value", "r");
    	    fgets(buff, 1023, f);
	    fclose(f);
	    if (atoi(buff)==0) {
		system("/usr/bin/killall advmame"); //hehe, you may want to comment this out
		system("/sbin/halt");
		exit(0);
	    }
	    usleep(100000);
	}
    }
}